#COMPILE EXE "Prog.exe"

%WINAPI           = 1
%IDC_ARROW        = 32512&
%MAX_PATH         = 260  ' max. length of full pathname
%WS_POPUP         = &H80000000
%WS_VISIBLE       = &H10000000
%WS_EX_TOOLWINDOW = &H00000080
%CS_VREDRAW       = &H1
%CS_HREDRAW       = &H2
%SM_CXSCREEN      = 0
%SM_CYSCREEN      = 1

TYPE RECT
  nLeft AS LONG
  nTop AS LONG
  nRight AS LONG
  nBottom AS LONG
END TYPE

TYPE tagMSG
  hwnd AS DWORD
  message AS DWORD
  wParam AS LONG
  lParam AS LONG
  time AS DWORD
  pt AS POINTAPI
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD

%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1

%XMIN_SIZE = 800
%YMIN_SIZE = 600

GLOBAL hWnd, gnParent, gnCodeID AS LONG

DECLARE FUNCTION GetCommandLineW LIB "KERNEL32.DLL" ALIAS "GetCommandLineW" () AS DWORD  

FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS WSTRINGZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

'FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
'                  BYVAL hPrevInstance AS LONG, _
'                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
'                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL zCmd        AS ASCIIZ * %MAX_PATH
'
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "FWPROCESS"

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(hInstance, zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbWndExtra    = 0
       wc.hInstance     = hInstance
       wc.hIcon         = 0
       wc.hCursor       = LoadCursor(0, BYVAL %IDC_ARROW)
       wc.hbrBackground = 0
       wc.lpszMenuName  = 0
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = 0
       IF RegisterClassEx(wc) THEN IsInitialized = -1
    END IF
'
    IF IsInitialized THEN

       dwExStyle = %WS_EX_TOOLWINDOW
       dwStyle = %WS_POPUP
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - %XMIN_SIZE) \ 2, 0)
       y = -2000
'
     ' Create The Window
       hWnd = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                              zClass, _               ' Class Name
                              zClass, _               ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              %XMIN_SIZE, _           ' Window Width
                              %YMIN_SIZE, _           ' Window Height
                              0, _                    ' No Parent Window
                              0, _                    ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL 0)                ' Dont Pass Anything To WM_CREATE
'
       IF hWnd THEN

          zCmd = ACODE$(PEEK$(GetCommandLineW(), 520))

          MsgBox "Original command line:" + $CR + _
                 CHR$(34) + "D:\Patrice Terrier\Exe\BBPlugin\FLY_Bubble.dll" + CHR$(34) + $CR + $CR + _
                 "PowerBASIC COMMAND$: " + CHR$(34) + COMMAND$ + CHR$(34) + $CR + _
                 "@lpCmdLine: " + CHR$(34) + @lpCmdLine + CHR$(34) + $CR + $CR + _
                 "API GetCommandLineW: " + CHR$(34) + zCmd + CHR$(34) + $CR + _
                 "is correct, while COMMAND$ and @lpCmdLine are wrong.", ,"PROG"

       END IF
    END IF
'
END FUNCTION

FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
END FUNCTION
